config/routes.rb
require 'sidekiq/web'

Rails.application.routes.draw do

  root to: 'pages#landing'

  get '/about', to: 'pages#about', as: :about
  get '/tos', to: 'pages#tos', as: :tos
  get '/demo', to: 'pages#demo', as: :demo

  get '/badness/:secret', to: 'pages#badness'

  match '/404', to: 'pages#not_found', via: :all
  match '/422', to: 'pages#unacceptable', via: :all
  match '/500', to: 'pages#internal_error', via: :all

  match '/wiki' => redirect('https://github.com/Gamocosm/Gamocosm/wiki'), as: :wiki, via: :get
  match '/issues' => redirect('https://github.com/Gamocosm/Gamocosm/issues'), as: :issues, via: :get
  match '/source' => redirect('https://github.com/Gamocosm/Gamocosm'), as: :source, via: :get
  match '/git_head' => redirect("https://github.com/Gamocosm/Gamocosm/tree/#{Gamocosm::GIT_HEAD}"), as: :git_head, via: :get
  match '/license' => redirect('https://github.com/Gamocosm/Gamocosm/blob/master/LICENSE'), as: :license, via: :get
  match '/blog' => redirect('http://gamocosm.com/blog/'), as: :blog, via: :get
  match '/irc' => redirect('https://webchat.esper.net/?channels=gamocosm'), as: :irc, via: :get
  match '/irc_history' => redirect('http://irc.gamocosm.com'), as: :irc_history, via: :get

  scope '/wiki' do
    match '/ftp_ssh' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/FTP-and-SSH'), as: :wiki_ftp_ssh, via: :get
    match '/minecraft_versions' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Installing-different-versions-of-Minecraft'), as: :wiki_minecraft_versions, via: :get
    match '/server_advanced_tab' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Server-advanced-tab-documentation'), as: :wiki_server_advanced_tab, via: :get
    match '/server_additional_info' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Additional-Info-for-Server-Admins'), as: :wiki_server_additional_info, via: :get
    match '/troubleshooting' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Troubleshooting'), as: :wiki_troubleshooting, via: :get
  end

  scope '/digital_ocean' do
    get '/setup', to: 'pages#digital_ocean_setup', as: :digital_ocean_setup

    match '/index' => redirect('https://www.digitalocean.com/?refcode=f787055e1099'), as: :digital_ocean_index, via: :get
    match '/index_no_ref' => redirect('https://www.digitalocean.com/'), as: :digital_ocean_index_no_ref, via: :get
    match '/pricing' => redirect('https://www.digitalocean.com/pricing/?refcode=f787055e1099'), as: :digital_ocean_pricing, via: :get
    match '/pricing_no_ref' => redirect('https://www.digitalocean.com/pricing/'), as: :digital_ocean_pricing_no_ref, via: :get
    match '/help' => redirect('https://www.digitalocean.com/help/'), as: :digital_ocean_help, via: :get
    match '/control_panel' => redirect('https://cloud.digitalocean.com'), as: :digital_ocean_control_panel, via: :get
    match '/status' => redirect('https://status.digitalocean.com'), as: :digital_ocean_status, via: :get

    get 'droplets', to: 'servers#show_digital_ocean_droplets', as: :show_digital_ocean_droplets
    delete 'droplets/:id', to: 'servers#destroy_digital_ocean_droplet', as: :destroy_digital_ocean_droplet
    get 'snapshots', to: 'servers#show_digital_ocean_snapshots', as: :show_digital_ocean_snapshots
    delete 'snapshots/:id', to: 'servers#destroy_digital_ocean_snapshot', as: :destroy_digital_ocean_snapshot
    get 'ssh_keys', to: 'servers#show_digital_ocean_ssh_keys', as: :show_digital_ocean_ssh_keys
    post 'ssh_keys', to: 'servers#add_digital_ocean_ssh_key', as: :add_digital_ocean_ssh_key
    delete 'ssh_keys/:id', to: 'servers#destroy_digital_ocean_ssh_key', as: :destroy_digital_ocean_ssh_key
    delete 'cache', to: 'servers#refresh_digital_ocean_cache', as: :refresh_digital_ocean_cache
  end

  scope '/external' do
    match '/github_student_developer_pack' => redirect('https://education.github.com/pack'), as: :external_github_student_developer_pack, via: :get
  end

  scope '/cuberite' do
    match '/' => redirect('http://cuberite.org'), as: :cuberite_website, via: :get
    match '/repo' => redirect('https://github.com/cuberite/cuberite'), as: :cuberite_repo, via: :get
  end

  Sidekiq::Web.use Rack::Auth::Basic, 'Protected Area' do |u, p|
    u == Gamocosm::SIDEKIQ_ADMIN_USERNAME && p == Gamocosm::SIDEKIQ_ADMIN_PASSWORD
  end
  mount Sidekiq::Web => '/sidekiq'

  devise_for :users, controllers: { registrations: 'registrations' }

  resources :servers, path: '/servers' do
    collection do
      post 'new', to: 'servers#create', as: :create
    end
    member do
      get 'delete'
      get 'start'
      get 'stop'
      get 'pause'
      get 'resume'
      get 'backup'
      get 'download'
      get 'reboot'
      put 'update_properties'
      post 'add_friend'
      post 'remove_friend'
      post 'command'
      get 'autoshutdown_enable'
      get 'autoshutdown_disable'
      get 'clear_logs'
    end
  end

end

app/views/pages/about.html.erb
<% title 'Gamocosm About' %>
<% content_for :meta_description, 'Gamocosm info, frequently asked questions, help, and troubleshooting' %>
<% meta_keywords ['Minecraft', 'hosting', 'open source', 'cloud', 'Digital Ocean', 'per-hour', 'info', 'faqs', 'help', 'troubleshooting'] %>
<div class="row">
	<div class="col-sm-12">
		<h1>About</h1>
		<p>
			Gamocosm is Free and Open-source Software.
			Gamocosm is free in that it <a href="https://www.gnu.org/philosophy/free-sw.html">respects your freedom and the community</a>.
			Gamocosm doesn't accept payment, no ads, and no tracking user data.
			Read our <a href="https://github.com/Gamocosm/Gamocosm/wiki/Security-and-Privacy">Security and Privacy</a> wiki page.
		</p>
		<p>
			I pay for all the development and production costs out of my pocket.
			I do this because I want to make something useful.
			I'll accept donations later if costs start being an issue.
			I intend to keep everything as transparent as possible.
		</p>
	</div>
</div>
<div class="row">
	<div class="col-sm-6">
		<h2>Contact</h2>
		<ul>
			<li>Submit an issue on <%= link_to 'GitHub', issues_path %></li>
			<li>Reddit PM "raekye" (probably the most reliable way!)</li>
			<li>IRC in <code>#gamocosm</code> on <a href="https://esper.net"><code>irc.esper.net</code></a> (<%= link_to 'web chat', irc_path %>) (<%= link_to 'chat history', irc_history_path %>)</li>
			<li>I have a terrible track record for IRC, but I set up a proper client now. I'm also on <a href="https://freenode.net"><code>chat.freenode.net</code></a> (you can direct message me on either network)</li>
			<li><a href="https://gitter.im/gamocosm/Lobby">Gitter chat</a></li>
		</ul>
	</div>
	<div class="col-sm-6">
		<h2>Source</h2>
		<p>The source code is on <%= link_to 'GitHub', source_path %>. Feel free to fork and send a pull request!</p>
	</div>
</div>
<div class="row">
	<div class="col-sm-12">
		<h2>Basic Information</h2>
		<dl class="faq">
			<dt>How much does per hour hosting cost?</dt>
			<dd>
				Let's say you and your friends play 2 hours a day, every day.
				That's ~60 hours a month.
				Typically, private servers only need 1GB-2GB of RAM.
				On <%= render_digital_ocean_referral_link('%s (%s)', 'Digital Ocean', digital_ocean_index_path, digital_ocean_index_no_ref_path) %>, this is 0.7-1.5 <em>cents</em> an hour (<%= render_digital_ocean_referral_link('%s, %s', 'pricing', digital_ocean_pricing_path, digital_ocean_pricing_no_ref_path) %>), or <strong>~$0.40-$0.80 a month</strong>.
			</dd>
			<dt>What is Digital Ocean?</dt>
			<dd>
				Digital Ocean is a general purpose cloud hosting provider.
				They host a lot of servers, not just for Minecraft, so their prices are about as low as servers get.
				A lot of developers/companies use Digital Ocean for their websites and apps; they're not just another Minecraft hosting startup.
				Running Minecraft on Digital Ocean is not only cheap, but you have unrestricted access to the server!
				It's more work to set up and manage a server on Digital Ocean yourself, but Gamocosm tries to bridge that gap.
			</dd>
			<dt>If Digital Ocean is hosting the server, what is Gamocosm doing?</dt>
			<dd>
				<p>Gamocosm sets up your server.
				Digital Ocean provides a bare, vanilla server, so you/Gamocosm needs to install and configure it to be a ready, secure Minecraft server.
				If you're interested, check this <%= link_to 'wiki page', wiki_server_additional_info_path %> for more info on the setup.</p>

				<p><strong>Secondly, Digital Ocean continues charging you when you <em>just</em> stop a server</strong>, because its resources are still allocated.
				When you stop a server on Gamocosm, it snapshots (backs up), and destroys your server.
				When you restart a server, Gamocosm recreates it from the snapshot.
				This way, you only pay when the server is in use.</p>
			</dd>
			<dt>That's a little confusing</dt>
			<dd>
				Just make sure you click "stop" on Gamocosm when you're done playing!
			</dd>
			<dt>Anything else I should know?</dt>
			<dd>
				Gamocosm just automates the general process of running Minecraft on a cloud server - you have <em>full access</em> to a Linux machine; you can do whatever you want with it!
				You can <%= link_to 'SSH, FTP', wiki_ftp_ssh_path %>, install mods, and even use entirely <%= link_to 'custom servers', wiki_minecraft_versions_path %>!
			</dd>
		</dl>
	</div>
</div>
<div class="row">
	<div class="col-sm-12">
		<h2>Donations/Internet Freedom (FAQs below)</h2>
		<p>
			At this time, I do not feel worthy of donations :P
			If possible, using <%= link_to 'Gamocosm\'s referral link for Digital Ocean', digital_ocean_index_path %>
			to subsidize server costs is appreciated
			(this goes directly to Gamocosm's Digital Ocean account, not mine).
			However, if you wish to support, I encourage everyone to support internet freedom groups such as Wikipedia.
			<strong>It's easy to gloss over their donation requests, but it is really important that we don't take them for granted!</strong>
		</p>
		<p>
			After doing my own research, I personally set up monthly donations to the following organizations:
			<ul>
				<li><a href="https://donate.mozilla.org">Mozilla</a> (consider trying the new <a href="https://www.mozilla.org">Firefox</a>!)</li>
				<li><a href="https://wikimediafoundation.org/wiki/Ways_to_Give">Wikipedia/Wikimedia Foundation</a></li>
				<li><a href="https://www.eff.org">Electronic Frontier Foundation</a> (international non-profit digital rights group)</li>
				<li><a href="https://freepress.net">Free Press.net</a> (they fight for Net Neutrality! I'm Canadian but it's still important!)</li>
			</ul>
			Really, looking at the big picture, it costs almost nothing.
			It only feels like a lot because "I don't have to" - bystander effect.
		</p>
		<p>
		I personally like these quotes (<strong>tl;dr? Fight the good fight! Fighto!</strong>):
			<blockquote>
				<p>
					Arguing that you don't care about the right to privacy because you have nothing to hide
					is no different than saying you don't care about free speech because you have nothing to say.
				</p>
				<footer>
					<a href="https://www.reddit.com/r/IAmA/comments/36ru89/just_days_left_to_kill_mass_surveillance_under/crglgh2/">Edward Snowden</a>
				</footer>
			</blockquote>
			<blockquote>
				<p>
					First they came for the Socialists, and I did not speak out -
					Because I was not a Socialist.

					Then they came for the Trade Unionists, and I did not speak out -
					Because I was not a Trade Unionist.

					Then they came for the Jews, and I did not speak out -
					Because I was not a Jew.

					Then they came for me - and there was no one left to speak for me.
				</p>
				<footer>
					Martin Niemoeller
				</footer>
			</blockquote>
			Other good reads:
			<ul>
				<li><a href="https://www.reddit.com/r/InsightfulQuestions/comments/t1dlo/why_do_people_care_so_much_about_privacy/c4iscqv/">
					"A lack of control over your information means a lack of control over your life"
				</a> (includes real examples)</li>
				<li><a href="https://www.reddit.com/r/changemyview/comments/1fv4r6/i_believe_the_government_should_be_allowed_to/cd89cqr/">
					Someone's personal experience
				</a> (there was controversy over edits, this is (to my understanding) the original post)</li>
			</ul>
		</p>
	</div>
</div>
<br />
<div class="row">
	<div class="col-sm-12">
		<h2>FAQs</h2>
		<dl class="faq">
			<dt>There's a bug!</dt>
			<dd>Do one of the following:<ul>
				<li>File an <%= link_to 'issue on GitHub', issues_path %></li>
				<li>Developers may be online on IRC at <code>#gamocosm</code> on <code>irc.esper.net</code>
				<li>Check the <%= link_to 'Troubleshooting page', wiki_troubleshooting_path %> on the wiki</li>
			</ul></dd>

			<dt>Why does it take so long to start/stop a server?</dt>
			<dd>Cloud hosting providers continue to charge you when your server is off, because resources are still allocated for you.
			What you can do is backup the server, destroy it, and restore the server from the backup the next time you need it.
			This is one of the things Gamocosm does for you automatically. It is a tradeoff so you can have the insanely low prices.
			Estimate: 2 minutes start time (5+ minutes first time creating server).
			Read more about how this works in the <%= link_to 'About page', about_path %>.
			</dd>

			<dt>What's the difference between the domain and IP address?</dt>
			<dd>
				An IP address locates an actual server.
				Domains map to IP addresses, and are used because they're easier to remember.
				Occasionally, the IP of your server may change, but the domain we create for your servers will always be the same.
				However, sometimes the old IP is cached somewhere along the pipeline, so you have to enter the IP directly.
			</dd>

			<dt>Where is Minecraft on my server?</dt>
			<dd>Your home directory is <code>/home/mcuser/</code>.
			Sometimes this is shortened as a tilda (<code>~</code>).
			Minecraft is installed in <code>~/minecraft/</code></dd>

			<dt>How do I edit the ops or whitelist?</dt>
			<dd><ul>
				<li>If there is already an operator on the server, he can op/deop/whitelist other players in chat; otherwise</li>
				<li>Start the Minecraft server</li>
				<li>Under "Send Command to Server", <code>op</code>, <code>deop</code>, or <code>whitelist add/remove</code> players</li>
			</ul></dd>

			<dt>Where are my server backups?</dt>
			<dd>Backups are saved on your server in <code>~/minecraft/backups/</code>.
			However, it is recommended that you download backups (e.g. via FTP) from time to time,
			and keep your own local backups</dd>

			<dt>How do I FTP or SSH?</dt>
			<dd>See this <%= link_to 'wiki page', wiki_ftp_ssh_path %>.</dd>

			<dt>How do I run different Minecraft versions, modded, or custom servers (e.g. Bukkit, Forge, Cuberite)?</dt>
			<dd>See this <%= link_to 'wiki page', wiki_minecraft_versions_path %></dd>

			<dt>Why/how do I set up Gamocosm with Digital Ocean?</dt>
			<dd>See <%= link_to 'this page', digital_ocean_setup_path %></dd>

			<dt>How do I resize a server?</dt>
			<dd>
				To increase the size:
				<ul>
					<li>Stop the server</li>
					<li>Under the "Advanced" tab, update "Digital Ocean size slug" to be one of [<%= @do_sizes.map { |x| x.slug }.join(', ') %>]</li>
					<li>Start the server</li>
				</ul>
				To decrease the size, you need to FTP or SSH to backup any files you want to keep (such as your world folder), and create a new server.
				Upload your files back on the server.
			</dd>

			<dt>What do you mean "Autoshutdown is experimental"?</dt>
			<dd>
				<p>
				Gamocosm works with a lot of infrastructure behind the scenes; a lot can go wrong that is and isn't Gamocosm's fault (we're working hard to iron out our bugs!).
				Autoshutdown is an especially tricky feature, and we can't guarantee that all cases are covered - especially when thing's outside Gamocosm's control go wrong.
				As much as feasible has been tested, but you shouldn't rely on it to shutdown your server before a month long hiatus, for example.
				On the other hand, if you play daily and check your email (for when Gamocosm tries to notify you that something went wrong), it's not really a problem if your server doesn't shut down one day.
				</p>
				<p>
				Why did we introduce this experimental feature?
				Because it has been requested the most! :P
				We - or more accurately I xD - don't have the manpower to test and push an enterprise-grade feature like this.
				The only way I can polish it is with user feedback and support.
				</p>
			</dd>

			<dt>Gamocosm got an error pinging/querying my server</dt>
			<dd>
				<ul>
					<li>Ensure <code>enable-query</code> is set in your <code>server.properties</code></li>
					<li>Ensure port 25565 is open to UDP (<code>(sudo) firewall-cmd --add-port=25565/udp</code> and <code>(sudo) firewall-cmd --permanent --add-port=25565/udp</code>)
				</ul>
				Both of these are done automatically on new servers, but you will have to do this manually for servers created before the autoshutdown update
			</dd>
		</dl>
	</div>
</div>

app/views/pages/demo.html.erb
<% title 'Gamocosm Demo' %>
<% content_for :meta_description, 'Gamocosm control panel demo' %>
<%= link_to 'Back to homepage', root_path, class: 'btn-lg btn-default' %>
<hr />
<div id="demo-servers" class="row">
	<h1 class="text-center">Minecraft Demo</h1>
</div>
<div class="row">
	<div class="col-sm-12">
		<%= render file: 'servers/show' %>
	</div>
</div>

app/views/pages/digital_ocean_setup.html.erb
<% title 'Digital Ocean Instructions - Gamocosm' %>
<% content_for :meta_description, 'Instructions for setting up Digital Ocean on Gamocosm' %>
<div class="row">
  <div class="col-sm-8">
    <h1>Digital Ocean Instructions</h1>
    <p>Gamocosm doesn't charge you for hosting servers (it's free).
    Your servers are hosted on Digital Ocean, a cloud hosting service.
    Gamocosm requires API access to do stuff such as setting up a new server or backing up and stopping servers.
    To learn more, see the <%= link_to 'About page', about_path %>.
    <ol>
      <li>Sign up on <%= render_digital_ocean_referral_link('%s (%s)', 'Digital Ocean', digital_ocean_index_path, digital_ocean_index_no_ref_path) %></li>
      <li>Click on Billing</li>
      <li>Click on Manage Payments</li>
      <li>Add billing information for Digital Ocean</li>
      <li>Click on Apps &amp; API</li>
      <li>Under "Personal Access Tokens", click "Generate new token"</li>
      <li>Check both "Read" and "Write" for the scope of the token, and click "Generate Token"</li>
      <li>Copy the token and save it in your settings</li>
    </ol>
  </div>
  <div class="col-sm-4">
    <%= image_tag 'digital_ocean-sign_up.png', size: '300x300', class: 'img-thumbnail' %>
  </div>
</div>
<br />
<div class="row text-center">
  <%= image_tag 'digital_ocean-billing.png', size: '900x580', class: 'img-thumbnail' %>
  <br />
  <br />
  <%= image_tag 'digital_ocean-api.png', size: '900x580', class: 'img-thumbnail' %>
</div>

app/views/pages/internal_error.html.erb
<% title 'Internal Error - Gamocosm' %>
<div class="row">
	<div class="col-sm-12">
		<h1>We're sorry, but something went wrong</h1>
		<p>
			This has been logged and we'll take a look at it.
			If it's urgent, or this keeps happening, please <%= link_to 'let us know about it!', issues_path %>
		</p>
		<hr />
		<ul>
			<li><%= link_to 'Home page', root_path %></li>
			<% if begin user_signed_in? rescue false end %>
				<li><%= link_to 'My servers', servers_path %></li>
			<% end %>
		</ul>
	</div>
</div>

app/views/pages/landing.html.erb
<% title 'Gamocosm · The open source Realms alternative' %>
<% content_for :meta_description, 'Gamocosm is an open source Realms alternative. It helps you host cloud Minecraft servers.' %>
<% meta_keywords ['Minecraft', 'hosting', 'open source', 'cloud', 'DigitalOcean', 'per-hour'] %>
<div class="container-fluid container-inverse">
<div id="landing_main" class="row">
	<div class="col-sm-12">
		<div class="jumbotron">
			<div class="container">
				<div class="row">
					<div class="col-sm-7">
						<h1>The <span class="text-primary">open</span><br>Realms alternative</h1>
						<p>
							Gamocosm is like a home coffee machine.
							Or a toolkit so you can do your own repairs.
							Or courses posted online so everyone can learn.
							Gamocosm helps you host your own servers.
						</p>
						<div class="actions">
							<%= link_to 'How it Works', about_path, class: 'btn btn-lg btn-default btn-reverse' %>
							<%= link_to 'Sign Up', new_user_registration_path, class: 'btn btn-lg btn-success btn-reverse' %>
						</div>
					</div>
					<div class="col-sm-5">
						<%= image_tag('splash.png', alt: 'Gamocosm control panel', class: 'img-responsive hidden-sm-block') %>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
</div>

<div class="features-wrapper">
	<%= image_tag('homepage/features.svg', alt: 'Gamocosm control panel', class: 'features-center') %>
	<div class="container">
		<div class="features">
			<div class="feature first">
				<h2>Why pay 24/7 if you don't play 24/7?</h2>
				<p>
					Gamocosm automates <%= link_to 'setting up', wiki_server_additional_info_path %> Minecraft servers on
					<%= render_digital_ocean_referral_link('%s (%s)', 'DigitalOcean', digital_ocean_index_path, digital_ocean_index_no_ref_path) %>,
					an established cloud server provider. You only need to pay per hour, so Gamocosm users average just <strong><%= link_to '$0.50-$2', about_path %> a month</strong>.
				</p>
			</div>
			<div class="feature second">
				<h2>Give access to family and friends</h2>
				<p>
					Get your server running just the way you like it, then add your friends so they can play while
					you're away. See a <%= link_to 'demo', demo_path %> of the control panel.
				</p>
			</div>
		</div>
		<div class="features">
			<div class="feature third">
				<h2>The server is yours and yours alone</h2>
				<p>
					You have full access to a Linux machine; you can install mods, additional software and even
					custom servers such as <%= link_to 'Cuberite', cuberite_website_path %>, the performant C++ Minecraft server.
					Read more about the setup on the <%= link_to 'wiki', wiki_path %>.
				</p>
			</div>
			<div class="feature fourth">
				<h2>Free as in freedom</h2>
				<p>
					It costs nothing to use Gamocosm; no bills, no ads, no tracking user habits.
					The <%= link_to 'source code', source_path %> is well documented and available for everyone's inspection
					and contribution.
				</p>
			</div>
		</div>
	</div>
</div>

app/views/pages/not_found.html.erb
<% title 'Page not Found - Gamocosm' %>
<div class="row">
	<div class="col-sm-12">
		<h1>This page does not exist</h1>
		<p>
			You may have mistyped the address or the page may have moved.
			If you think this is an error, please <%= link_to 'let us know about it!', issues_path %>
		</p>
		<hr />
		<ul>
			<li><%= link_to 'Home page', root_path %></li>
			<% if user_signed_in? %>
				<li><%= link_to 'My servers', servers_path %></li>
			<% end %>
		</ul>
	</div>
</div>

app/views/pages/tos.html.erb
<% title 'Terms of Service - Gamocosm' %>
<% content_for :meta_description, 'Gamocosm terms of service' %>
<div class="row">
	<div class="col-sm-12">
		<div class="page-header">
			<h1>Terms of Service</h1>
		</div>
		<p>
			Gamocosm is licensed under the <%= link_to 'GNU Public License V2', license_path %>.
			<br />
			By using Gamocosm, you also agree to Mojang's <a href="https://account.mojang.com/documents/minecraft_eula">Minecraft EULA</a>.
			<br />
			These terms may change at any time; it is your duty to keep up to date with them.
			<br />
			I'm not a lawyer; please don't be evil :)
		</p>
	</div>
</div>

app/views/pages/unacceptable.html.erb
<% title 'Unprocessable Entity - Gamocosm' %>
<div class="row">
	<div class="col-sm-12">
		<h1>The change you wanted was rejected</h1>
		<p>
			Maybe you tried to change something you didn't have access to.
			If you think this is an error, please <%= link_to 'let us know about it!', issues_path %>
		</p>
		<hr />
		<ul>
			<li><%= link_to 'Home page', root_path %></li>
			<% if user_signed_in? %>
				<li><%= link_to 'My servers', servers_path %></li>
			<% end %>
		</ul>
	</div>
</div>